#ifndef ZASM_LINK_NAMESPACE_H
#define ZASM_LINK_NAMESPACE_H 1

#include <zasm/namespace.h>

#define LINK_NAMESPACE_T(O) ((struct link_namespace_t *)(O))
struct link_namespace_t
{
  // public
  struct namespace_t namespace;
};

#define LINK_LEVEL_T(O) ((struct link_level_t *)(O))
struct link_level_t
{
  // public
  struct ns_level_t level;

  // private
  struct link_lookup_t *exprs;
  struct link_global_t *globals;

  struct link_expr_alloc_t *expr_alloc;
  struct link_global_alloc_t *global_alloc;
  struct link_lookup_alloc_t *lookup_alloc;
  struct link_entry_alloc_t *entry_alloc;
  struct string_alloc_t *string_alloc;
};

#include <zasm/expr.h>
#include <zasm/link_expr.h>
#include <zasm/link_entry.h>
#include <zasm/link_lookup.h>
#include <zasm/link_global.h>
#include <zasm/string_alloc.h>
struct link_namespace_t *link_namespace_new();
void link_namespace_fill(struct link_namespace_t *ns);
void link_namespace_add_level(struct link_namespace_t *ns);
void link_namespace_del_level(struct link_namespace_t *ns);
int  link_namespace_is_empty(struct link_namespace_t *ns);
void link_namespace_add(struct link_namespace_t *ns, char *name, struct expr_t *expr, int addr, int page, int instr_start);
void link_namespace_lookup(struct link_namespace_t *ns, struct expr_t *expr, int addr, int page, int instr_start, int *dest);
struct link_entry_t *link_namespace_lookup_direct(struct link_namespace_t *ns, char *name);
void link_namespace_export(struct link_namespace_t *ns, char *name);
void link_namespace_do_export(struct link_namespace_t *ns, struct link_entry_t *entry);
void link_namespace_delete(struct link_namespace_t *ns);
void link_namespace_free(struct link_namespace_t *ns);

struct link_level_t *link_level_new(struct link_namespace_t *parent);
void link_level_fill(struct link_level_t *level, struct link_namespace_t *parent);
struct link_entry_t *link_level_lookup_new(struct link_level_t *level, char *name);
void link_level_delete(struct link_level_t *level);
void link_level_free(struct link_level_t *level);

#endif
