#include <zasm/feeder.h>
#include <zasm/stream.h>
#include <zasm/tokens.h>
#include <zasm/list.h>
#include <zasm/preprocessor.h>
#include <zasm/lexer.h>
#include <zasm/str.h>
#include <zasm/string.h>
#include <zasm/errors.h>
#include <zasm/pp_macro.h>
#include <zasm/pp_namespace.h>
#include <zasm/parser.h>
#include <stdio.h>
#include <string.h>

static struct preprocessor_t *pp = NULL;
static struct token_t global_name, global_space;


static inline struct token_t pc_parser_0(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t result;
    result.type = TOK_EXPR;
    result.value.t_struct_expr_t_p = parse_expr(input, token, &(pp->expr_alloc));
    return result;
  
}
static inline 
struct token_t expr_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_0(input,token);
}

static inline struct token_t pc_parser_1(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_2(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

  struct token_t paren;
    paren=pc_parser_1(input,token,TOK_PAREN_OPEN);
  if ((paren.type == TOK_PC_FAIL)||(paren.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      paren.type = TOK_PC_FAIL;
    return paren;
  }
  pc_called = 1;
  pc_retval=process_block_p(input,token,TOK_PAREN_CLOSE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
feeder_unget(input,*token);
  feeder_unget(input,paren);
  *token = feeder_get(input);
  paren.type = TOK_PC_SUCCESS;
  return paren;

}

static inline struct token_t pc_parser_3(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_2(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=process_block_p(input,token,TOK_PAREN_CLOSE,TOK_NEWLINE);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}
static inline 
struct token_t process_arguments_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_3(input,token);
}

static inline struct token_t pc_parser_4(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_5(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = get_block_p(input,token,TOK_COMMA,TOK_PAREN_CLOSE);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = pc_parser_4(input,token,TOK_COMMA);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = get_block_p(input,token,TOK_COMMA,TOK_PAREN_CLOSE);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_6(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  if (token->type != TOK_PAREN_OPEN)
  {
    result.type = TOK_PC_FAIL1;
    return result;
  }
  *token = feeder_get(input);
  result = pc_parser_5(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1)||(token->type != TOK_PAREN_CLOSE))
    result.type = TOK_PC_FAIL;
  *token = feeder_get(input);
  return result;
}

static inline struct token_t pc_parser_7(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_8(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = get_block_p(input,token,TOK_COMMA,TOK_PAREN_CLOSE,TOK_NEWLINE);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = pc_parser_7(input,token,TOK_COMMA);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = get_block_p(input,token,TOK_COMMA,TOK_PAREN_CLOSE,TOK_NEWLINE);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_9(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_6(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=pc_parser_8(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}
static inline 
struct token_t arguments_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_9(input,token);
}

static inline struct token_t pc_parser_10(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t result;
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list_new();
    return result;
  
}
static inline 
struct token_t empty_list_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_10(input,token);
}

static inline struct token_t pc_parser_11(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_12(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_13(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
struct token_t result;   result=pc_parser_11(input,token,TOK_NAME,TOK_VARARG);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
  pc_retval=pc_parser_12(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return result;
}
static inline 
struct token_t arg_name_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_13(input,token);
}

static inline struct token_t pc_parser_14(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_15(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_16(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
struct token_t result;   result=pc_parser_14(input,token,TOK_COMMA);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
  pc_retval=pc_parser_15(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return result;
}
static inline 
struct token_t comma_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_16(input,token);
}

static inline struct token_t pc_parser_17(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_18(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = arg_name_p(input,token);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = comma_p(input,token);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = arg_name_p(input,token);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_19(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  pc_retval=pc_parser_17(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_18(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return pc_retval;

}

static inline struct token_t pc_parser_20(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  if (token->type != TOK_PAREN_OPEN)
  {
    result.type = TOK_PC_FAIL1;
    return result;
  }
  *token = feeder_get(input);
  result = pc_parser_19(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1)||(token->type != TOK_PAREN_CLOSE))
    result.type = TOK_PC_FAIL;
  *token = feeder_get(input);
  return result;
}

static inline struct token_t pc_parser_21(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_20(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=empty_list_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}
static inline 
struct token_t define_args_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_21(input,token);
}

static inline struct token_t pc_parser_22(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_23(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_24(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = arg_name_p(input,token);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = comma_p(input,token);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = arg_name_p(input,token);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_25(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = pc_parser_22(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_24(input,token);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = pc_parser_23(input,token,TOK_NEWLINE);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}
static inline 
struct token_t macro_args_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_25(input,token);
}

static inline struct token_t pc_parser_26(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_27(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_28(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_29(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_30(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
struct token_t result;   pc_retval=pc_parser_27(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  result=pc_parser_28(input,token,TOK_NAME);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
  pc_retval=pc_parser_29(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return result;
}

static inline struct token_t pc_parser_31(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  if (token->type != TOK_PAREN_OPEN)
  {
    result.type = TOK_PC_FAIL1;
    return result;
  }
  *token = feeder_get(input);
  result = pc_parser_30(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1)||(token->type != TOK_PAREN_CLOSE))
    result.type = TOK_PC_FAIL;
  *token = feeder_get(input);
  return result;
}

static inline struct token_t pc_parser_32(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_33(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_34(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
struct token_t result;   result=pc_parser_32(input,token,TOK_NAME);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
  pc_retval=pc_parser_33(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return result;
}

static inline struct token_t pc_parser_35(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_31(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=pc_parser_34(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_36(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t name;
    struct token_t result;

      pc_retval=pc_parser_26(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  name=pc_parser_35(input,token);
  if ((name.type == TOK_PC_FAIL)||(name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      name.type = TOK_PC_FAIL;
    return name;
  }
  pc_called = 1;
result.position = name.position;
    result.type = TOK_INTEGER;
    if (pp_namespace_defined(pp->ns, name.value.t_char_p))
      result.value.t_int = 1;
    else
      result.value.t_int = 0;
    token_free(name);
    return result;
  
}
static inline 
struct token_t defined_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_36(input,token);
}

static inline struct token_t pc_parser_37(struct feeder_t *input, struct token_t *token,int type1)
{
  struct token_t result;
  if ((token->type == type1))
    result.type = TOK_PC_FAIL1;
  else
  {
    result = *token;
    *token = feeder_get(input);
  }
  return result;
}

static inline struct token_t pc_parser_38(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (1)
  {
    result = pc_parser_37(input,token,TOK_NEWLINE);
    if (result.type == TOK_PC_FAIL)
    {
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_PC_SUCCESS;
      return result;
    }
  }
}

static inline struct token_t pc_parser_39(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_40(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    T_WARNING(*token, "skipping redefinition of special token\n");
      pc_retval=pc_parser_38(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_39(input,token,TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t define_special_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_40(input,token);
}

static inline struct token_t pc_parser_41(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_42(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_43(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_42(input,token,TOK_NAME);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=define_special_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_44(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  if (token->type == TOK_SPACE)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_45(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_46(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_44(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=pc_parser_45(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_47(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_48(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t name;
    struct token_t args;
    struct token_t body;

      pc_retval=pc_parser_41(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  name=pc_parser_43(input,token);
  if ((name.type == TOK_PC_FAIL)||(name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      name.type = TOK_PC_FAIL;
    return name;
  }
  pc_called = 1;
if (name.type == TOK_NAME)
    {  args=define_args_p(input,token);
  if ((args.type == TOK_PC_FAIL)||(args.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      args.type = TOK_PC_FAIL;
    return args;
  }
  pc_called = 1;
  pc_retval=pc_parser_46(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  body=get_block_p(input,token,TOK_NEWLINE);
  if ((body.type == TOK_PC_FAIL)||(body.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      body.type = TOK_PC_FAIL;
    return body;
  }
  pc_called = 1;
  pc_retval=pc_parser_47(input,token,TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
pp_namespace_define(pp->ns, name.value.t_char_p, args.value.t_struct_list_t_p, body.value.t_struct_list_t_p);
      token_free(name);
    }
    name.type = TOK_PC_SUCCESS;
    return name;
  
}
static inline 
struct token_t define_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_48(input,token);
}

static inline struct token_t pc_parser_49(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_50(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_51(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  if (token->type == TOK_SPACE)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_52(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_53(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_51(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=pc_parser_52(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_54(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t name;
    struct token_t args;
    struct token_t body;
      pc_retval=pc_parser_49(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  name=pc_parser_50(input,token,TOK_NAME);
  if ((name.type == TOK_PC_FAIL)||(name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      name.type = TOK_PC_FAIL;
    return name;
  }
  pc_called = 1;
  args=define_args_p(input,token);
  if ((args.type == TOK_PC_FAIL)||(args.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      args.type = TOK_PC_FAIL;
    return args;
  }
  pc_called = 1;
  pc_retval=pc_parser_53(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  body=get_block_p(input,token,TOK_NEWLINE);
  if ((body.type == TOK_PC_FAIL)||(body.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      body.type = TOK_PC_FAIL;
    return body;
  }
  pc_called = 1;
pp_namespace_redef(pp->ns, name.value.t_char_p, args.value.t_struct_list_t_p, body.value.t_struct_list_t_p);
    token_free(name);
    name.type = TOK_PC_SUCCESS;
    return name;
  
}
static inline 
struct token_t redef_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_54(input,token);
}

static inline struct token_t pc_parser_55(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_56(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_57(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t name;
      pc_retval=pc_parser_55(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  name=pc_parser_56(input,token,TOK_NAME);
  if ((name.type == TOK_PC_FAIL)||(name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      name.type = TOK_PC_FAIL;
    return name;
  }
  pc_called = 1;
pp_namespace_del(pp->ns, name.value.t_char_p);
    token_free(name);
    name.type = TOK_PC_SUCCESS;
    return name;
  
}
static inline 
struct token_t undef_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_57(input,token);
}

static inline struct token_t pc_parser_58(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
pp_namespace_add_level(pp->ns); pc_retval.type = TOK_PC_SUCCESS; return pc_retval;
}
static inline 
struct token_t begin_section_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_58(input,token);
}

static inline struct token_t pc_parser_59(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
pp_namespace_del_level(pp->ns); pc_retval.type = TOK_PC_SUCCESS; return pc_retval;
}
static inline 
struct token_t end_section_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_59(input,token);
}

static inline struct token_t pc_parser_60(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_61(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t end_file;
    char *filename;

      pc_retval=pc_parser_60(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
if (token->type == TOK_STRING)
      filename = STR_CONCAT(pp->path, token->value.t_char_p);
    else if (token->type == TOK_ISTRING)
      filename = preprocessor_get_include_file(pp, token->value.t_char_p);
    else
    {
      pc_retval.type = TOK_PC_FAIL;
      return pc_retval;
    }
    end_file.position.file = "";
    end_file.position.line_begin = 0;
    end_file.position.line_end = 0;
    end_file.type = TOK_END_FILE;
    end_file.value.t_char_p = pp->path;
    pp->path = str_get_path(filename);
    feeder_unget(input, end_file);
    feeder_add_action(input,action_new(ACTION_EXECUTE_T(lexer_execute), NULL, NULL, lexer_new(string_new(filename))));
    token_free(*token);
    *token = feeder_get(input);
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t include_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_61(input,token);
}

static inline struct token_t pc_parser_62(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_63(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t end_file;

      end_file=pc_parser_62(input,token,TOK_END_FILE);
  if ((end_file.type == TOK_PC_FAIL)||(end_file.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      end_file.type = TOK_PC_FAIL;
    return end_file;
  }
  pc_called = 1;
pp->path = end_file.value.t_char_p;
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t end_file_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_63(input,token);
}

static inline struct token_t pc_parser_64(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_65(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  pc_retval=skip_block_p(input,token,TOK_ENDIF);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_64(input,token,TOK_ENDIF);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t else_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_65(input,token);
}

static inline struct token_t pc_parser_66(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  pc_retval=skip_block_p(input,token,TOK_ELSE,TOK_ELSEIF,TOK_ELSEIFDEF,TOK_ELSEIFNDEF,TOK_ENDIF);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
if (token->type == TOK_ELSEIF)
      token->type = TOK_IF;
    else if (token->type == TOK_ELSEIFDEF)
      token->type = TOK_IFDEF;
    else if (token->type == TOK_ELSEIFNDEF)
      token->type = TOK_IFNDEF;
    else
      *token = feeder_get(input);
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t iffalse_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_66(input,token);
}

static inline struct token_t pc_parser_67(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_68(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t expr;
      pc_retval=process_block_p(input,token,TOK_NEWLINE,TOK_THEN);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  expr=expr_p(input,token);
  if ((expr.type == TOK_PC_FAIL)||(expr.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      expr.type = TOK_PC_FAIL;
    return expr;
  }
  pc_called = 1;
  pc_retval=pc_parser_67(input,token,TOK_NEWLINE,TOK_THEN);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
if (!expr_calculate(expr.value.t_struct_expr_t_p))
    {  pc_retval=iffalse_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
}
    expr.type = TOK_PC_SUCCESS;
    return expr;
  
}
static inline 
struct token_t if_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_68(input,token);
}

static inline struct token_t pc_parser_69(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_70(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_71(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_72(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_73(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t name;
      pc_retval=pc_parser_69(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  name=pc_parser_70(input,token,TOK_NAME);
  if ((name.type == TOK_PC_FAIL)||(name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      name.type = TOK_PC_FAIL;
    return name;
  }
  pc_called = 1;
  pc_retval=pc_parser_71(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_72(input,token,TOK_THEN, TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
if (!pp_namespace_defined(pp->ns, name.value.t_char_p))
    {  pc_retval=iffalse_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
}
    token_free(name);
    name.type = TOK_PC_SUCCESS;
    return name;
  
}
static inline 
struct token_t ifdef_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_73(input,token);
}

static inline struct token_t pc_parser_74(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_75(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_76(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_77(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_78(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t name;
      pc_retval=pc_parser_74(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  name=pc_parser_75(input,token,TOK_NAME);
  if ((name.type == TOK_PC_FAIL)||(name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      name.type = TOK_PC_FAIL;
    return name;
  }
  pc_called = 1;
  pc_retval=pc_parser_76(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_77(input,token,TOK_THEN, TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
if (pp_namespace_defined(pp->ns, name.value.t_char_p))
    {  pc_retval=iffalse_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
}
    token_free(name);
    name.type = TOK_PC_SUCCESS;
    return name;
  
}
static inline 
struct token_t ifndef_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_78(input,token);
}

static inline struct token_t pc_parser_79(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result.type = TOK_PC_SUCCESS;
  return result;
}
static inline 
struct token_t endif_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_79(input,token);
}

static inline struct token_t pc_parser_80(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
T_ERROR(*token, "syntax error\n");return pc_retval;
}
static inline 
struct token_t syntax_error_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_80(input,token);
}

static inline struct token_t pc_parser_81(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_82(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_83(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t message;
      pc_retval=pc_parser_81(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  message=pc_parser_82(input,token,TOK_STRING);
  if ((message.type == TOK_PC_FAIL)||(message.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      message.type = TOK_PC_FAIL;
    return message;
  }
  pc_called = 1;
T_ERROR(message, "%s\n", message.value.t_char_p);
    token_free(message);
    message.type = TOK_PC_SUCCESS;
    return message;
  
}
static inline 
struct token_t error_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_83(input,token);
}

static inline struct token_t pc_parser_84(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_85(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_86(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t message;
      pc_retval=pc_parser_84(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  message=pc_parser_85(input,token,TOK_STRING);
  if ((message.type == TOK_PC_FAIL)||(message.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      message.type = TOK_PC_FAIL;
    return message;
  }
  pc_called = 1;
T_WARNING(message, "%s\n", message.value.t_char_p);
    token_free(message);
    message.type = TOK_PC_SUCCESS;
    return message;
  
}
static inline 
struct token_t warning_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_86(input,token);
}

static inline struct token_t pc_parser_87(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_88(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_89(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t message;
      pc_retval=pc_parser_87(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  message=pc_parser_88(input,token,TOK_STRING);
  if ((message.type == TOK_PC_FAIL)||(message.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      message.type = TOK_PC_FAIL;
    return message;
  }
  pc_called = 1;
T_DEBUG(message, "%s\n", message.value.t_char_p);
    token_free(message);
    message.type = TOK_PC_SUCCESS;
    return message;
  
}
static inline 
struct token_t debug_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_89(input,token);
}

static inline struct token_t pc_parser_90(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_91(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t step;
      pc_retval=process_block_p(input,token,TOK_DO, TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  step=expr_p(input,token);
  if ((step.type == TOK_PC_FAIL)||(step.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      step.type = TOK_PC_FAIL;
    return step;
  }
  pc_called = 1;
  pc_retval=pc_parser_90(input,token,TOK_DO, TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
pc_retval.type = TOK_INTEGER;
    pc_retval.value.t_int = expr_calculate(step.value.t_struct_expr_t_p);
    return pc_retval;
  
}
static inline 
struct token_t for_step(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_91(input,token);
}

static inline struct token_t pc_parser_92(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_93(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
pc_retval.type = TOK_INTEGER; pc_retval.value.t_int = 1; return pc_retval;
}

static inline struct token_t pc_parser_94(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
pc_retval.type = TOK_INTEGER; pc_retval.value.t_int = 1; return pc_retval;
}

static inline struct token_t pc_parser_95(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  switch (token->type)
  {
  case TOK_STEP:
    *token = feeder_get(input);
    result = for_step(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
			TOK_DO:
    *token = feeder_get(input);
    result = pc_parser_93(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
			TOK_NEWLINE:
    *token = feeder_get(input);
    result = pc_parser_94(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  default:
    result.type = TOK_PC_FAIL1;
    return result;
  }
}

static inline struct token_t pc_parser_96(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_97(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t t_from, t_to, t_step, body,name;
    struct list_t *list;

    name = global_name;
      pc_retval=process_block_p(input,token,TOK_TO);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  t_from=expr_p(input,token);
  if ((t_from.type == TOK_PC_FAIL)||(t_from.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      t_from.type = TOK_PC_FAIL;
    return t_from;
  }
  pc_called = 1;
  pc_retval=pc_parser_92(input,token,TOK_TO);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=process_block_p(input,token,TOK_STEP,TOK_DO,TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  t_to=expr_p(input,token);
  if ((t_to.type == TOK_PC_FAIL)||(t_to.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      t_to.type = TOK_PC_FAIL;
    return t_to;
  }
  pc_called = 1;
  t_step=pc_parser_95(input,token);
  if ((t_step.type == TOK_PC_FAIL)||(t_step.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      t_step.type = TOK_PC_FAIL;
    return t_step;
  }
  pc_called = 1;
  body=get_block_p(input,token,TOK_ENDFOR);
  if ((body.type == TOK_PC_FAIL)||(body.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      body.type = TOK_PC_FAIL;
    return body;
  }
  pc_called = 1;
  pc_retval=pc_parser_96(input,token,TOK_ENDFOR);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
list = substitute_for_from(body.value.t_struct_list_t_p,
			       name.value.t_char_p,
			       expr_calculate(t_from.value.t_struct_expr_t_p),
			       expr_calculate(t_to.value.t_struct_expr_t_p),
			       t_step.value.t_int);
    feeder_unget(input, *token);
    feeder_add_list(input, list);
    *token = feeder_get(input);
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t for_from_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_97(input,token);
}

static inline struct token_t pc_parser_98(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_99(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = get_block_p(input,token,TOK_DO,TOK_COMMA,TOK_NEWLINE);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = pc_parser_98(input,token,TOK_COMMA);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = get_block_p(input,token,TOK_DO,TOK_COMMA,TOK_NEWLINE);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_100(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_101(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_102(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t name, in, body;
    struct list_t *list;
    name = global_name;
      pc_retval=process_block_p(input,token,TOK_DO,TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  in=pc_parser_99(input,token);
  if ((in.type == TOK_PC_FAIL)||(in.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      in.type = TOK_PC_FAIL;
    return in;
  }
  pc_called = 1;
  pc_retval=pc_parser_100(input,token,TOK_DO,TOK_NEWLINE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  body=get_block_p(input,token,TOK_ENDFOR);
  if ((body.type == TOK_PC_FAIL)||(body.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      body.type = TOK_PC_FAIL;
    return body;
  }
  pc_called = 1;
  pc_retval=pc_parser_101(input,token,TOK_ENDFOR);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
list = substitute_for_in(body.value.t_struct_list_t_p, name.value.t_char_p, in.value.t_struct_list_t_p);
    feeder_unget(input, *token);
    feeder_add_list(input, list);
    *token = feeder_get(input);
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;    
  
}
static inline 
struct token_t for_in_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_102(input,token);
}

static inline struct token_t pc_parser_103(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_104(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_105(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_106(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = pc_parser_103(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_105(input,token,TOK_NAME);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = pc_parser_104(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}

static inline struct token_t pc_parser_107(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  switch (token->type)
  {
  case TOK_FROM:
    *token = feeder_get(input);
    result = for_from_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
			TOK_IN:
    *token = feeder_get(input);
    result = for_in_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  default:
    result.type = TOK_PC_FAIL1;
    return result;
  }
}

static inline struct token_t pc_parser_108(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  global_name=pc_parser_106(input,token);
  if ((global_name.type == TOK_PC_FAIL)||(global_name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      global_name.type = TOK_PC_FAIL;
    return global_name;
  }
  pc_called = 1;
  pc_retval=pc_parser_107(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return pc_retval;

}
static inline 
struct token_t for_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_108(input,token);
}

static inline struct token_t pc_parser_109(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_110(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_111(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_112(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t args;
    struct token_t body;
    struct token_t endm;
      pc_retval=pc_parser_109(input,token,TOK_MACRO);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_110(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  args=macro_args_p(input,token);
  if ((args.type == TOK_PC_FAIL)||(args.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      args.type = TOK_PC_FAIL;
    return args;
  }
  pc_called = 1;
  body=get_block_p(input,token,TOK_ENDM);
  if ((body.type == TOK_PC_FAIL)||(body.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      body.type = TOK_PC_FAIL;
    return body;
  }
  pc_called = 1;
  endm=pc_parser_111(input,token,TOK_ENDM);
  if ((endm.type == TOK_PC_FAIL)||(endm.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      endm.type = TOK_PC_FAIL;
    return endm;
  }
  pc_called = 1;
pp_namespace_define(pp->ns, global_name.value.t_char_p, args.value.t_struct_list_t_p, body.value.t_struct_list_t_p);
    token_free(global_name);
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t macro_def_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_112(input,token);
}

static inline struct token_t pc_parser_113(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_114(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct pp_macro_t *macro;
    struct token_t args;
    struct list_t *arguments;

    if (!(macro = pp_namespace_lookup(pp->ns, global_name.value.t_char_p)))
    {
      pc_retval.type = TOK_PC_FAIL1;
      return pc_retval;
    }
    if (list_is_empty(macro->args))
      arguments = list_new();
    else
    {  pc_retval=pc_parser_113(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=process_arguments_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  args=arguments_p(input,token);
  if ((args.type == TOK_PC_FAIL)||(args.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      args.type = TOK_PC_FAIL;
    return args;
  }
  pc_called = 1;
arguments = args.value.t_struct_list_t_p;
    }
    arguments = substitute_macro(macro->body, macro->args, arguments, *token);
    if (global_space.type != TOK_PC_SUCCESS)
      list_add_end(arguments, global_space);
    feeder_unget(input, *token);
    feeder_add_list(input, arguments);
    *token = feeder_get(input);
    args.type = TOK_PC_SUCCESS;
    return args;
  
}
static inline 
struct token_t macro_subst_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_114(input,token);
}

static inline struct token_t pc_parser_115(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct list_t *list;
    struct token_t result;

    if (global_space.type != TOK_PC_SUCCESS)
    {
      feeder_unget(input, *token);
      *token = global_space;
    }
    return global_name;
  
}
static inline 
struct token_t global_name_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_115(input,token);
}

static inline struct token_t pc_parser_116(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_117(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  if (token->type == TOK_SPACE)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_118(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_119(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_117(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=pc_parser_118(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_120(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_121(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=macro_def_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=macro_subst_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=global_name_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_122(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  global_name=pc_parser_116(input,token,TOK_NAME);
  if ((global_name.type == TOK_PC_FAIL)||(global_name.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      global_name.type = TOK_PC_FAIL;
    return global_name;
  }
  pc_called = 1;
  global_space=pc_parser_119(input,token);
  if ((global_space.type == TOK_PC_FAIL)||(global_space.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      global_space.type = TOK_PC_FAIL;
    return global_space;
  }
  pc_called = 1;
  pc_retval=pc_parser_120(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_121(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return pc_retval;

}
static inline 
struct token_t name_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_122(input,token);
}

static inline struct token_t pc_parser_123(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
pc_retval.type = TOK_NEWLINE; return pc_retval;
}
static inline 
struct token_t backslash_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_123(input,token);
}

static inline struct token_t pc_parser_124(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  switch (token->type)
  {
  case TOK_DEFINED:
    *token = feeder_get(input);
    result = defined_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_DEFINE:
    *token = feeder_get(input);
    result = define_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_REDEF:
    *token = feeder_get(input);
    result = redef_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_UNDEF:
    *token = feeder_get(input);
    result = undef_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_PP_BEGIN_SECTION:
    *token = feeder_get(input);
    result = begin_section_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_PP_END_SECTION:
    *token = feeder_get(input);
    result = end_section_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_INCLUDE:
    *token = feeder_get(input);
    result = include_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_IF:
    *token = feeder_get(input);
    result = if_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_IFDEF:
    *token = feeder_get(input);
    result = ifdef_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_IFNDEF:
    *token = feeder_get(input);
    result = ifndef_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_ELSEIF:
    *token = feeder_get(input);
    result = else_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_ELSEIFDEF:
    *token = feeder_get(input);
    result = else_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_ELSEIFNDEF:
    *token = feeder_get(input);
    result = else_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_ELSE:
    *token = feeder_get(input);
    result = else_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_ENDIF:
    *token = feeder_get(input);
    result = endif_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_FOR:
    *token = feeder_get(input);
    result = for_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_ERROR:
    *token = feeder_get(input);
    result = error_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_WARNING:
    *token = feeder_get(input);
    result = warning_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_DEBUG:
    *token = feeder_get(input);
    result = debug_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
		TOK_BACKSLASH:
    *token = feeder_get(input);
    result = backslash_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  default:
    result.type = TOK_PC_FAIL1;
    return result;
  }
}

static inline struct token_t pc_parser_125(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result = *token;
  *token = feeder_get(input);
  return result;
}

static inline struct token_t pc_parser_126(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_124(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=end_file_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=name_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=pc_parser_125(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

struct token_t preprocessor_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_126(input,token);
}



















































    






/*
__INLINE_PARSER endfor_p =
  {
    struct token_t next;
    int v;

    if (!pp->fors)
      T_ERROR(*token, "unbalanced #for/#endfor pair\n");
    if (pp->fors->type == PP_FOR_IN)
    {
      next = list_get_begin(pp->fors->args.in.in);
      if (next.type == TOK_LIST_END)
	preprocessor_del_for(pp);
      else
	{
	  list_free(pp->fors->args.in.current);
	  pp->fors->args.in.current = next.value.t_struct_list_t_p;
	  feeder_unget(input, *token);
	  feeder_add_list(input, list_copy(body.value.t_struct_list_t_p));
	  *token = feeder_get(input);
	}
    }
    else if (pp->fors->type == PP_FOR_FROM)
    {
      v = pp->fors->args.from.current + pp->fors->args.from.step;
      if ((pp->fors->args.from.to - v)*(pp->fors->args.from.step) < 0)
        preprocessor_del_for(pp);
      else
      {
	pp->fors->args.from.current = v;
	feeder_unget(input, *token);
	feeder_add_list(input, list_copy(body.value.t_struct_list_t_p));
	*token = feeder_get(input);
      }
    }
    else
      ERROR("internal error\n");
    pc_retval.type = TOK_SUCCESS;
    return pc_retval;
  };

__INLINE_PARSER endmacro_p =
  {
    pp_namespace_del_level(pp->macro_args);
    pc_retval.type = TOK_SUCCESS;
    return pc_retval;
  }
	      */





/*
__INLINE_PARSER arg_subst_p =
  {
    struct pp_macro_t *macro;

    if (!(macro = pp_namespace_lookup(pp->macro_args, global_name.value.t_char_p)));
    {
      pc_retval.type = TOK_PC_FAIL1;
      return pc_retval;
    }
    feeder_unget(input, *token);
    feeder_add_list(input, list_copy(macro->body));
    *token = feeder_get(input);    
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;    
  };

__INLINE_PARSER for_subst_p =
  {
    struct pp_for_t *pf;

    for (pf = pp->fors; pf; pf = pf->up)
    {
      if (0==strcmp(pf->name, global_name.value.t_char_p))
	{
	  if (pf->type == PP_FOR_IN)
	    {
	      feeder_unget(input, *token);
	      feeder_add_list(input, list_copy(pf->args.in.current));
	      *token = feeder_get(input);
	      pc_retval.type = TOK_PC_SUCCESS;
	      return pc_retval;
	    }
	  else if (pf->type == PP_FOR_FROM)
	    {
	      pc_retval.position = global_name.position;
	      pc_retval.type = TOK_INTEGER;
	      pc_retval.value.t_int = pf->args.from.current;
	      return pc_retval;
	    }
	  else
	    ERROR("internal error\n");
	}
    }
    pc_retval.type = TOK_PC_FAIL1;
    return pc_retval;
  };

__INLINE_PARSER process_token = 
  {
    struct token_t result;
    while (1)
    {
      result <- preprocessor_p;
      if ((result.type == TOK_SUCCESS)||(result.type == TOK_SPACE))
	continue;
      return result
    }
  };

__INLINE_PARSER name_paste_p =
  {
    struct token_t name1, result, name2;
    char *val;
    struct list_t list;
    name1 = global_name;
    pc(pc_token(TOK_PASTE));
    pc(pc_spaces);
    result <- process_token;
    feeder_unget(feeder,*token);
    if (result.type == TOK_LIST)
    {
      name2 = list_get_begin(result.value.t_struct_list_t_p);
      feeder_add_list(input, result.value.t_struct_list_t_p);
    }
    else
      name2 = result;
    if ((name2.type == TOK_NAME)||(name2.type == TOK_VARARG))
    {
      val = STR_CONCAT(name1.value.t_char_p,name2.value.t_char_p);
      token_free(name2);
      token_free(name1);
      name1.value.t_char_p = string_new(val);
    }
    else
      feeder_unget(feeder, name2);
    *token = name1;
    result.type = TOK_SUCCESS;
    return result;
  };

__INLINE_PARSER paste_p =
  {
    struct token_t name1, result, name2;
    name1 <- try({struct token_t t; t<-pc_token(TOK_COMMA);pc(pc_spaces);pc(pc_token(TOK_PASTE));return t;});
    result <- process_token;
    feeder_unget(feeder,*token);
    if (result.type == TOK_LIST)
    {
      name2 = list_get_begin(result.value.t_struct_list_t_p);
      feeder_add_list(input, result.value.t_struct_list_t_p);
    }
    else
      name2 = result;
    if ((name2.type == TOK_PAREN_CLOSE)||(name2.type == TOK_COMMA))
      *token = name2;
    else
    {
      feeder_unget(feeder, name2);
      *token = name1;
    }
    result.type = TOK_SUCCESS;
    return result;
  }
*/









void preprocessor_execute(struct feeder_t *input, struct stream_t *output, struct preprocessor_t *preprocessor)
{
  struct token_t result;
  int i = 0;

  pp = preprocessor;
  if (pp->look_ahead.type == TOKENS_COUNT)
    pp->look_ahead = feeder_get(input);
  while (1)
    {
      if (pp->look_ahead.type == TOK_END_OF_FILE)
	break;
      result = preprocessor_p(input, &(pp->look_ahead));
      if (result.type == TOK_PC_SUCCESS)
	continue;
      if (result.type == TOK_LIST)
	{
	  list_add_list_end(&(output->list), result.value.t_struct_list_t_p);
	  list_free(result.value.t_struct_list_t_p);
	}
      else if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
	T_ERROR(pp->look_ahead, "syntax error\n");
      else
	stream_put(output, result);
      i++;
      if (i > 10)
	break;
    }
  expr_alloc_reset(preprocessor->expr_alloc);
  if (pp->look_ahead.type == TOK_END_OF_FILE)
    {
      stream_put(output, pp->look_ahead);
      preprocessor_free(preprocessor);
      feeder_free(input);
    }
}
